# import
from PIL import Image, ImageDraw

# constants
S = 4000
N = int(S * S / 2)
OFFSET = 1

# prepare
image = Image.new("1", (S, S), 1)
draw = ImageDraw.Draw(image)
removed = [False for i in range(0, N)]

# calculate and draw
x, y = 0, 0

for i in range(2, N):
    if y == 0:
        y = x + 1
        x = 0
    else:
        y -= 1
        x += 1

    if not removed[i]:
        draw.ellipse((x, y, x+OFFSET, y+OFFSET), fill=0)
        for j in range(i*i, N, i):
            removed[j] = True

    if i % (N / 50) == 0:
        print('.', end='')

# save image
image.save("out.png")
