# import
from PIL import Image, ImageDraw

# constants
S = 500
N = S * S
OFFSET = 2
DIR = [(0, -1), (-1, 0), (0, 1), (1, 0)]

# prepare
image = Image.new("1", (S, S), 1)
draw = ImageDraw.Draw(image)
removed = [False for i in range(0, N)]

# calculate and draw
x, y, d, last_l, length = int(S/2), int(S/2), 3, 0, 0

for i in range(2, N):
    dx, dy = DIR[d]
    x, y = x + dx, y + dy
    length += 1    

    if not removed[i]:
        draw.ellipse((x, y, x+OFFSET, y+OFFSET), fill=0)
        for j in range(i*i, N, i):
            removed[j] = True

    if (d in [0, 2] and length == last_l) or (d in [1, 3] and length > last_l):
        d = (d + 1) % 4
        last_l = length
        length = 0
                
    if i % (N / 50) == 0:
        print('.', end='')

# save image
image.save("out.png")
